/*
 * Center.java
 *
 * Created on March 9, 2001, 1:04 PM
 */

import java.net.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author  Steven Perron
 * @version 
 */
public class Center extends javax.swing.JFrame {
    Queue clients;
    javax.swing.JList list;
    Tally stats;

    /**
    * @param args the command line arguments
    */
    public static void main (String [] args) {
        new Center();
    }

    public void save()
    {
        try
	{
	    ObjectOutputStream o = new ObjectOutputStream( new FileOutputStream( "stats.dat" ) );
            o.writeObject(stats);
            o.close();
        }catch(Exception e) {}
    }

    public synchronized void update() {
        list.setListData( clients.data.toArray() );
       
    }
    private class ClientThread extends Thread {
        int port;
        public ClientThread( int p )
        {
            port = p;
        }
        public void run()
        {
           try
           {
                ServerSocket sock = new ServerSocket(port);
            
            
            while (true)
            {
               Socket newClient = sock.accept();
               DataInputStream in = new DataInputStream( newClient.getInputStream() );
               ClientProfile c = new ClientProfile( in.readInt(), 
                                                    newClient.getInetAddress() );
	       stats.add( new java.util.Date() );
               clients.push( c );
               update();
               newClient.close();
            }
           }
	   catch ( IOException e )
           {
             System.out.println( "Setting up thread: " + e );
	     System.exit(1);
           }
         }
    }
    
    private class HelperThread extends Thread {
        int port;
        public HelperThread( int p )
        {
            port = p;
        }
        
        public void run()
        {
            ServerSocket sock = null;
            try {
                sock = new ServerSocket(port);
            } catch ( IOException e )
            {
                System.out.println( e );
            }
            
            while (true)
            {
                try {
                    Socket newClient = sock.accept();
                    ClientProfile c = (ClientProfile)clients.pop();
                    new ObjectOutputStream(newClient.getOutputStream()).writeObject(c);
                    update();
                    newClient.close();
                }catch (Exception e )
                {
                    System.out.println( e );
                }
            }
        }
    }
    
    
    /** Creates new Center */
    public Center() {
        super( "Control Center" );
        try {
            stats = (Tally)new ObjectInputStream( 
                           new FileInputStream("stats.dat") ).readObject();
        } catch( Exception e )
        {
	    e.printStackTrace();
            stats = new Tally();
        }
	
	javax.swing.JButton b = new javax.swing.JButton("View Statistics");
        b.addActionListener( new java.awt.event.ActionListener()
        {
	    public void actionPerformed( java.awt.event.ActionEvent e )
            {
                new StatViewer( stats ).show();
            }
        });

        getContentPane().add( "South", b );
        clients = new Queue();
        list = new javax.swing.JList();
        setBounds( 200, 200, 500, 400 );
        show();
        getContentPane().add( "Center", list );

        addWindowListener( new java.awt.event.WindowAdapter()
        {
	     public void windowClosing( java.awt.event.WindowEvent e )
             {
		save();
		System.exit(0);
             }
        });
       
        Thread t = new ClientThread(4321);
        t.start();
        t = new HelperThread(5432);
        t.start();
    }
}
